Skip to navigation

Update an invoice schedule

View as Markdown

Updates a pending invoice schedule. You can use this API operation to update invoice schedules in the following aspects:

  • Update notes and pending invoice schedule items
  • Update orders associated with invoice schedules
  • Remove or add invoice schedule items For more samples, see Edit invoice schedules

Restrictions and limitations

When updating invoice schedules through the REST API, keep the following restrictions and limitations in mind:

  • You can only update invoice schedule items in Pending status.
  • You can only add orders or specific subscriptions to pending invoice schedules, and remove orders or specific subscriptions from pending invoice schedules.
  • For the invoice schedule items that you want to update, you must include the new values for these items in the request.
  • For the invoice schedule items that you want to keep unchanged, you must include all the existing information about these items in the request. Otherwise, the existing invoice schedule items that you do not include in the request are deleted.
  • For the orders that you want to keep unchanged for an invoice schedule, you must include all the existing order numbers associated with the invoice schedule in the request. Otherwise, the existing orders that you do not include in the request are removed.

Note: This operation is available only if you have the Billing Schedule feature enabled.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Path parameters

scheduleKeystringRequired

The unique ID or number of the invoice schedule to be updated. For example, 2c92c8955bd63cc1015bd7c151af02ab or IS-0000001.

Headers

Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Request

This endpoint expects an object.
additionalSubscriptionsToBilllist of stringsOptional
A list of the numbers of the subscriptions that need to be billed together with the invoice schedule. One invoice schedule can have at most 600 additional subscriptions.
invoiceSeparatelybooleanOptional
Whether the invoice items created from the invoice schedule appears on a separate invoice when Zuora generates invoices.
nextRunDatedateOptional

The run date of the next execution of the invoice schedule.

By default, the next run date is the same as the run date of next pending invoice schedule item. The date can be overwritten by a different date other than the default value. If the invoice schedule has completed the execution, the next run date is null.

notesstringOptional<=255 characters
Comments on the invoice schedule.
orderslist of stringsOptional
A list of the IDs or numbers of the orders associated with the invoice schedule. One invoice schedule can be associated with at most 10 orders. The orders specified in this field override all the existing orders associated with the invoice schedule.
scheduleItemslist of objectsOptional
Container for invoice schedule items. The maximum number of schedule items is 50. The invoice schedule items specified in this field override all the existing invoice schedule items.
specificSubscriptionslist of objectsOptional

A list of the numbers of specific subscriptions associated with the invoice schedule.

  • If the subscriptions specified in this field belong to the orders specified in the orders field, only the specific subscriptions instead of the orders are associated with the invoice schedule.
  • If only the orders field is specified, all the subscriptions from the order are associated with the invoice schedule.

The specific subscriptions specified in this field override all the existing specific subscriptions associated with the invoice schedule.

Example:

{
  "orders": [
    "O-00000001", "O-00000002"
  ],
  "specificSubscriptions": [
    {
      "orderKey": "O-00000001",
      "subscriptionKey": "S-00000001"
    }
  ]
}
  • For the order with number O-00000001, only subscription S-00000001 contained in the order is associated with the invoice schedule.
  • For the order with number O-00000002, all subscriptions contained in the order are associated with the invoice schedule.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
accountIdstringOptional
The ID of the customer account that the invoice schedule belongs to.
actualAmountdoubleOptional

The actual amount that needs to be billed during the processing of the invoice schedule.

By default, the actual amount is the same as the total amount. Even if order changes occur like Remove Product or Cancel Subscription, the value of the totalAmount field keeps unchanged. The value of the actualAmount field reflects the actual amount to be billed.

additionalSubscriptionsToBilllist of stringsOptional
A list of the numbers of the subscriptions that need to be billed together with the invoice schedule. One invoice schedule can have at most 600 additional subscriptions.
billedAmountdoubleOptional
The amount that has been billed during the processing of the invoice schedule.
currencystringOptional

The currency of the billing documents generated during the processing of the invoice schedule. Note: - This field is available only if you have the Multiple Currencies feature enabled.

  • If you have the Multiple Currencies feature disabled, the corresponding account’s default currency is always used.
idstringOptional
The unique ID of the invoice schedule.
invoiceSeparatelybooleanOptional
Whether the invoice items created from the invoice schedule appears on a separate invoice when Zuora generates invoices.
nextRunDatedateOptional
The run date of the next execution of invoice schedule. By default, the next run date is the same as run date of next pending invoice schedule item. It can be overwritten with a different date other than the default value. When the invoice schedule has completed the execution, the next run date is null.
notesstringOptional<=255 characters
Comments on the invoice schedule.
numberstringOptional
The sequence number of the invoice schedule.
orderslist of stringsOptional
A list of the IDs or numbers of the orders associated with the invoice schedule. One invoice schedule can be associated with at most 10 orders.
scheduleItemslist of objectsOptional
Container for schedule items. One invoice schedule can have at most 50 invoice schedule items.
specificSubscriptionslist of objectsOptional
A list of the numbers of specific subscriptions associated with the invoice schedule.
statusenumOptional
The status of the invoice schedule.
Allowed values:
totalAmountdoubleOptional
The total amount that needs to be billed during the processing of the invoice schedule. The value of this field keeps unchanged once invoice schedule items are created.
unbilledAmountdoubleOptional
The amount that is waiting to be billed during the processing of the invoice schedule.
organizationLabelstringOptional

Indicates the organization assigned to the Invoice Schedule for multi-org.

Errors

4XX
Client Request Error
500
Internal Server Error